#include	"mac.h"

extern	int	prdc1();
extern	int	prdc2();
extern	int	prdc3();
extern	int	prdc4();
extern	int	prnull();
extern	int	prequ();
extern	int	prglobal();
extern	int	pralign();
extern	int	prorg();
extern	int	prseg();
extern	int	prds();
extern	int	prend();
extern	int	prdcs();
extern	int	prstruc();
extern	int	prends();
extern	int	princl();
extern	int	prlsb();

extern	int	pedc1();
extern	int	pedc2();
extern	int	pedc3();
extern	int	pedc4();
extern	int	pealign();
extern	int	peorg();
extern	int	peseg();
extern	int	peds();
extern	int	peend();
extern	int	petitle();
extern	int	penull();
extern	int	pedcs();
extern	int	pelist();
extern	int	penlist();
extern	int	peincl();



int	nline	=	0;		/* nth input line */
int	liston	=	TRUE;		/* list-nlist switch */
int	lline	=	0;		/* nth listing line */
int	lpage	=	0;		/* page number */
int	nsyms	=	0;		/* # of symbols */
int	nlit	=	0;		/* # of literals in  pool */
int	errcount=	0;		/* # errors */
char	flags[26];			/* start up options */
/* gone with stdio
int	afd;
*/
FILE	*mout;				/* m.out fd */
int	wf;				/* word listing flag */
int	ff;				/* format listing flag */
int	bp;				/* bit pattern */
struct st *globptr;			/* pointer for global refs */
int	globno;				/* globals counter */

char	fbuf[256];			/* format string buffer */
char	*p;				/* char line pointer */
char	*fp = fbuf;			/* format string next char */
char	*fst = fbuf;			/* format string first "  */
char	buf[MAXBUF];			/* line buffer */
char	clabel[64];			/* identifiers & strings */
char	ctitle[32];			/* title buffer */
char	*literals;			/* literal labels */

struct	fd	*memory;		/* start of brk'd core & fmt tab */
struct	st	*symtab;		/* pointer to symbol table */
struct	st	*lithd;			/* pointer to literal list */
struct	st	*litnxt;		/* pointer to next literal */
char		*opcode;		/* pointer to opcode table */
struct	tbl	*parse;			/* start of parser table */
char		*endcore;		/* end of core pointer */
char		*coreptr;		/* pointer to next free byte */
int		*code;			/* pointer to assembled code */

int	sym;				/* next symbol */
int	mem;				/* member of symbol */
int	oprstac[16];			/* general opr. stack */
int	relstac[16];			/* relocatability word */
int	nstruc	=		0;		/* structure offset counter */

char	(*fn)();

int	eof;				/* eof indicator flag */
/* gone with stdio
int	unit;
*/
FILE	*intercd;			/* intercode file ptr */
int	bl;				/* byte length in bits */
int	bu;				/* bytes in addr. */
int	ib;				/* bytes in instr. */
int	ibx;				/* bounded instr's flag */
short	lcntr;				/* curr. locn counter */
int	length;				/* length of cur. instr. */

int	reloc;				/* current reloc factor */
int	mreloc;				/* internal reloc word */
int	class;				/* label class of expression */

char	*plabel[ ] =	{		/* pseudo op labels */
	0,
	0,
	0,
	0,
	"equ",
	"global",
	"align",
	"org",
	"seg",
	"ds",
	"end",
	"title",
	"eject",
	"dc",
	"struc",
	"ends",
	"list",
	"nlist",
	"include",
	"lsb",
	0
	};

int	(*pradr[ ])() =	{
	prdc1,
	prdc2,
	prdc3,
	prdc4,
	prequ,
	prglobal,
	pralign,
	prorg,
	prseg,
	prds,
	prend,
	prlsb,		/* title - start new local sym block */
	prnull,		/* eject */
	prdcs,			/* special dc */
	prstruc,
	prends,
	prnull,
	prnull,
	princl,
	prlsb,
	0
	};

int	(*peadr[ ])() =	{
	pedc1,
	pedc2,
	pedc3,
	pedc4,
	penull,		/* equ */
	penull,		/* global */
	pealign,
	peorg,
	peseg,
	peds,
	peend,
	petitle,
	penull,		/* eject */
	pedcs,
	penull,		/* struc 14 */
	penull,		/* ends */
	pelist,
	penlist,
	peincl,		/* include source */
	penull,		/* local symbol block */
	0
	};

char	hextab[ ] =	"0123456789abcdef";
char	octtab[ ] =	"01234567";
char	dectab[ ] =	"0123456789";
char	alptab[ ] =	"abcdefghijklmnopqrstuvwxyz._";
char	xalptab[ ] =	"._";			/* extra alpha's */
char	oprtab[ ] =	"+-*/%><~&|";

char	chtab[ ] =	{

	0x50, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0,
	0xf0, 0x31, 0x60, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0,
	0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0,
	0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0,
	0x30, 0x00, 0x90, 0x00, 0x00, 0x84, 0x88, 0xa0,
	0x00, 0x00, 0x82, 0x80, 0x40, 0x81, 0x10, 0x83,
	0x20, 0x21, 0x22, 0x23, 0x24, 0x25, 0x26, 0x27,
	0x28, 0x29, 0x00, 0x70, 0x86, 0xb0, 0x85, 0x00,
	0x00, 0x1a, 0x1b, 0x1c, 0x1d, 0x1e, 0x1f, 0x10,
	0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10,
	0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10,
	0x10, 0x10, 0x10, 0x00, 0x00, 0x00, 0x00, 0x10,
	0xc0, 0x1a, 0x1b, 0x1c, 0x1d, 0x1e, 0x1f, 0x10,
	0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10,
	0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10,
	0x10, 0x10, 0x10, 0x00, 0x89, 0x00, 0x87, 0xf0

	};

struct	st	*symhash[SYMHASH+1];		/* symbol hash indices */
struct	ht	head;				/* header record */

struct	lt	locn[LCOUNT];
/*	gone with stdio
struct	bt	ibuf;
*/
FILE		*src = stdin;
char		outbuf[BUFSIZ];
struct	it	intercode;
struct	pt	pt;


#ifdef		PDP11

int	bitmask[ ] =	{

	0x0000,	0x0001,	0x0003,	0x0007,	0x000f,
		0x001f,	0x003f,	0x007f,	0x00ff,
		0x01ff,	0x03ff,	0x07ff,	0x0fff,
		0x1fff,	0x3fff,	0x7fff,	0xffff

	};

#endif


#ifdef		INTERDATA

int	bitmask[ ] =	{

	0x00000000,  0x00000001,  0x00000003,  0x00000007,  0x0000000f,
		     0x0000001f,  0x0000003f,  0x0000007f,  0x000000ff,
		     0x000001ff,  0x000003ff,  0x000007ff,  0x00000fff,
		     0x00001fff,  0x00003fff,  0x00007fff,  0x0000ffff,
		     0x0001ffff,  0x0003ffff,  0x0007ffff,  0x000fffff,
		     0x001fffff,  0x003fffff,  0x007fffff,  0x00ffffff,
		     0x01ffffff,  0x03ffffff,  0x07ffffff,  0x0fffffff,
		     0x1fffffff,  0x3fffffff,  0x7fffffff,  0xffffffff

	};

#endif

int	startad	=	0;		/* start address */
struct inclstk 	inclstk[MAXINCL];	/* include stack */
int	inclevel;			/* include level */
char	*currfile;			/* name of current source */
int	listchs;			/* no of chars in listing line */

struct	lsb	*lsb_head;		/* head of lsb chain */
struct	lsb	*lsb_last;		/* tail of lsb chain */
