#include	"../mac/mac.h"
#include	"mactab.h"

extern	plit();
extern	plab();
extern	pclass();
extern	phed();
extern	pops();
extern	pfmt();
extern	parg();
extern	pend();



char	*p;
char	clabel[64];
char	buf[512];
char	literals[NLIT][8];

char	hextab[ ] =	"0123456789abcdef";
char	dectab[ ] =	"0123456789";
char	octtab[ ] =	"01234567";
char	alptab[ ] = "\
ABCDEFGHIJKLMNOPQRSTUVWXYZ\
abcdefghijklmnopqrstuvwxyz._";
char	oprtab[ ] =	"+-*/%><~&|";

char	(*fn)();
int	(*avec[ ])() =	{
	plit,		/* literals */
	plab,		/* pre-def labels */
	pclass,		/* label classes */
	phed,		/* header */
	pops,		/* opcodes */
	pfmt,		/* formats */
	parg,		/* instr args */
	pend,		/* output form code */
	0
	};

char	*lvec[ ] =	{
	"literals",
	"labels",
	"classes",
	"header",
	"opcodes",
	"formats",
	"args",
	"end",
	0
	};

int	tp	= 0;
int	nslot	= 0;
int	nlit	= 0;
int	nfmt	= 0;
int	nops	= 0;
int	nsym	= 0;
int	nline	= 0;
int	nerr	= 0;
int	sym;
int	mem;
char	mem4[4];
int	fd;

struct	node	*tree;
struct	tbl	*s2;
struct	tbl	*parse;
struct	fd	format[NFMT];
struct	od	*opcode;
struct	st	symtab[NSYM];			/* 8 pre-defined labels */
struct	ht	head;
struct	ocdump	*dmplst;

/*
 *
 *	Pre-defined sections of the parser.
 *
 *	E1:	expression evaluater
 *	S1:	part of the source line before the args
 *	S3:	part of the line after the args.
 *
 */


struct	tbl	e1[NE1] =	{

/*  0 */ { -LPL,	'=',	1,	LITP	},
/*  1 */ { -OPR,	0,	4,	OOPR	},
/*  2 */ { -OPR,	1,	4,	OOPR	},
/*  3 */ { -OPR,	7,	4,	OOPR	},
/*  4 */ { LBL,	NUL,	8,	OLBL	},
/*  5 */ { CON,	NUL,	8,	OCON	},
/*  6 */ { -CHR,	'!',	8,	OCHR	},
/*  7 */ { MCH,	NUL,	NUL,	GOTO	},

/*  8 */ { OPR,	NUL,	1,	OOPR	},
/*  9 */ { MCH,	NUL,	NUL,	RETN	},
};

struct	tbl	s1[NS1] =	{

/*  0 */ { LBL,	NUL,	6,	ALBL	},		/* label tag */
/*  1 */ { EOL,	NUL,	NUL,	OREC	},
/*  2 */ { EOF,	NUL,	NUL,	ENDP	},
/*  3 */ { COM,	NUL,	10,	NOOP	},
/*  4 */ { SPA,	NUL,	12,	NOOP	},
/*  5 */ { MCH,	NUL,	NUL,	OERR	},
 
/*  6 */ { SPA,	NUL,	12,	NOOP	},		/*  6 */
/*  7 */ { COM,	NUL,	10,	NOOP	},
/*  8 */ { EOL,	NUL,	NUL,	OREC	},
/*  9 */ { MCH,	NUL,	NUL,	OERR	},

/* 10 */ { EOL,	NUL,	NUL,	OREC	},		/* 10 */
/* 11 */ { MCH,	NUL,	NUL,	OERR	},

/* 12 */ { LBL,	NUL,	16,	DOPV	},		/* 12 */
/* 13 */ { EOL,	NUL,	NUL,	OREC	},
/* 14 */ { COM,	NUL,	10,	NOOP	},
/* 15 */ { MCH,	NUL,	NUL,	OERR	},

/* 16 */ { SPA,	NUL,	20,	NOOP	},		/* 16 */
/* 17 */ { EOL,	NUL,	NUL,	OREC	},
/* 18 */ { COM,	NUL,	10,	NOOP	},
/* 19 */ { MCH,	NUL,	NUL,	OERR	},

/* 20 */   /* start of user-defined section */		/* 20 */
};

struct	tbl	s3[NS3] =	{

/*  0 */ { SPA,	NUL,	1,	NOOP	},
/*  1 */ { COM,	NUL,	2,	NOOP	},
/*  2 */ { EOL,	NUL,	NUL,	OREC	},
/*  3 */ { MCH,	NUL,	NUL,	OERR	},

							/* 4 */
};
